#  Copyright (c) 2022. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
#  Morbi non lorem porttitor neque feugiat blandit. Ut vitae ipsum eget quam lacinia accumsan.
#  Etiam sed turpis ac ipsum condimentum fringilla. Maecenas magna.
#  Proin dapibus sapien vel ante. Aliquam erat volutpat. Pellentesque sagittis ligula eget metus.
#  Vestibulum commodo. Ut rhoncus gravida arcu.

import PySimpleGUI as sg


class ITXOApplication:
    class GUI:
        def __init__(self):
            self.size: (int, int) = (18, 1)
            self.application_name = 'サンプル'
            self.window_title_prefix = 'ITXO - '

    def __init__(self):
        self._gui = self.GUI()
        self._version = 'v1.0.0'
        self._window: sg.Window = None

    def _create_layout(self) -> []:
        layout = [
            [sg.Text("ITXOチーム作成", size=self._gui.size)],
            [sg.InputText("test", key="hoge", size=self._gui.size)],
            [sg.Cancel('キャンセル', key='cancel')]
        ]
        return layout

    def _event_loop(self):

        while True:
            event, values = self._window.read()
            print('event', event, values)

            cont = self._event_handler(event, values)
            if cont is None:
                cont = True

            if not cont:
                break

    def _event_handler(self, event: str, values: []) -> bool:
        """
        イベント処理
        :rtype: bool
        """
        if event in (None, 'cancel'):
            print('exit')
            return False

    def run(self):
        self._window = sg.Window("{} - {} @{}".format(
            self._gui.window_title_prefix,
            self._gui.application_name,
            self._version),
            layout=self._create_layout())
        self._event_loop()


def launch(clazz: ITXOApplication):
    '''
    ITXOアプリケーションを起動する
    :param clazz: ITXOアプリケーションクラス
    :return: None
    '''
    app = clazz()
    app.run()
    del app


if __name__ == '__main__':
    launch(ITXOApplication)
